# A curated list of work and projects using manif

## They cite us

You may find on Google Scholar publications citing either:

- the [Lie theory paper][jsola18] accompanying **manif** - see [here][jsola18-scholar]
- the [**manif** library paper][deray20] - see [here][deray20-scholar]

## They use manif

- [`lie-group-controllers`][lie-group-controllers-repo], header-only C++ libraries containing controllers designed for Lie Groups.
- [`bipedal-locomotion-framework`][bipedal-locomotion-framework], The BipedalLocomotionFramework project is a suite of libraries for achieving bipedal locomotion on humanoid robots.
- [`kalmanif`][kalmanif], A small collection of Kalman Filters on Lie groups.
- [`cpp_filter`][cpp_filter], Kalman filter using C++ and Manif.

Your project is not listed here? Let us know about it!

[//]: # (URLs)

[jsola18]: http://arxiv.org/abs/1812.01537
[jsola18-scholar]: https://scholar.google.com/scholar?oi=bibs&cites=16456301708818968338
[deray20]: https://joss.theoj.org/papers/10.21105/joss.01371
[deray20-scholar]: https://scholar.google.fr/scholar?oi=bibs&hl=fr&cites=1235228860941456363

[lie-group-controllers-repo]: https://github.com/dic-iit/lie-group-controllers
[bipedal-locomotion-framework]: https://github.com/dic-iit/bipedal-locomotion-framework
[kalmanif]: https://github.com/artivis/kalmanif
[cpp_filter]: https://github.com/aalbaali/cpp_filter
