# Publications

## Citing manif

If you use this software, please consider citing [this paper][deray20] as follows:

```latex
@article{Deray-20-JOSS,
  doi = {10.21105/joss.01371},
  url = {https://doi.org/10.21105/joss.01371},
  year = {2020},
  publisher = {The Open Journal},
  volume = {5},
  number = {46},
  pages = {1371},
  author = {Jérémie Deray and Joan Solà},
  title = {Manif: A micro {L}ie theory library for state estimation in robotics applications},
  journal = {Journal of Open Source Software}
}
```

You can also consider citing [this paper][jsola18] as follows:

```latex
@techreport{SOLA-18-Lie,
    Address = {Barcelona},
    Author = {Joan Sol\`a and Jeremie Deray and Dinesh Atchuthan},
    Institution = {{Institut de Rob\`otica i Inform\`atica Industrial}},
    Number = {IRI-TR-18-01},
    Title = {A micro {L}ie theory for state estimation in robotics},
    Howpublished="\url{http://arxiv.org/abs/1812.01537}",
    Year = {2018}
}
```

Note that this reference is the one referred to throughout the code documentation.
Since this is a versioned work, please refer to [version 4, available here][jsola18v],
of the paper when cross-referencing with the **manif** documentation.
This will give the appropriate equation numbers.

## Lie group cheat sheets

In a rush? Check out our Lie group theory take away, the
[Lie group cheat sheet][cheat-sheet]
(or hit [dowload][cheat-sheet-download]).

[jsola18]: http://arxiv.org/abs/1812.01537
[jsola18v]: http://arxiv.org/abs/1812.01537v4
[deray20]: https://joss.theoj.org/papers/10.21105/joss.01371
[cheat-sheet]: https://github.com/artivis/manif/blob/devel/paper/Lie_theory_cheat_sheet.pdf
[cheat-sheet-download]: https://github.com/artivis/manif/raw/devel/paper/Lie_theory_cheat_sheet.pdf